> ## Documentation Index
> Fetch the complete documentation index at: https://docs.mangopay.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List Transactions for a Bank Account

This call returns all the transactions of a given bank account, whether the bank account is the source (pay-in) or the target (payout) of the transaction.

### Path parameters

<ParamField path="BankAccountId" type="string" required>
  The unique identifier of the bank account.
</ParamField>

### Query parameters

<ParamField query="Status" type="string">
  **Allowed values:** `CREATED`, `SUCCEEDED`, `FAILED`

  The status of the transaction. You can filter on multiple values by separating them with a comma.
</ParamField>

<ParamField query="ResultCode" type="string">
  The code indicating the result of the operation. You can filter on multiple values by separating them with a comma.
</ParamField>

<ParamField query="BeforeDate" type="Unix timestamp">
  The date before which the transaction was created (based on the transaction’s `CreationDate` parameter). You can filter on a specific time range by using both the `AfterDate` and `BeforeDate` query parameters.
</ParamField>

<ParamField query="AfterDate" type="Unix timestamp">
  The date after which the transaction was created (based on the transaction’s `CreationDate` parameter). You can filter on a specific time range by using both the `AfterDate` and `BeforeDate` query parameters.
</ParamField>

<ParamField query="Type" type="string">
  **Allowed values:** `PAYIN`, `TRANSFER`, `CONVERSION`, `PAYOUT`

  The type of the transaction. You can filter on multiple values by separating them with a comma.
</ParamField>

<ParamField query="Nature" type="string">
  **Allowed values:** `REGULAR`, `REPUDIATION`, `REFUND`, `SETTLEMENT`

  The nature of the transaction, providing more information about the context in which the transaction occurred. You can filter on multiple values by separating them with a comma.
</ParamField>

### Responses

<AccordionGroup>
  <Accordion title="200 - Payouts-only example">
    <ResponseField name="Array (Transactions)" type="array">
      The list of transactions created by the platform.

      <Expandable title="properties">
        <ResponseField name="Object (transaction)" type="object">
          The transaction created by the platform.

          <Expandable title="properties">
            <ResponseField name="Id" type="string">
              Max length: 128 characters (see [data formats](/api-reference/overview/data-formats) for details)

              The unique identifier of the object.
            </ResponseField>

            <ResponseField name="Tag" type="string">
              Max. length: 255 characters

              Custom data that you can add to this object.\
              For transactions (pay-in, transfer, payout), you can use this parameter to identify corresponding information regarding the user, transaction, or payment methods on your platform.
            </ResponseField>

            <ResponseField name="CreationDate" type="Unix timestamp">
              The date and time at which the object was created.
            </ResponseField>

            <ResponseField name="AuthorId" type="string">
              The unique identifier of the user at the source of the transaction.
            </ResponseField>

            <ResponseField name="CreditedUserId" type="string">
              **Default value:** The unique identifier of the owner of the credited wallet.

              The unique identifier of the user whose wallet is credited.
            </ResponseField>

            <ResponseField name="DebitedFunds" type="object">
              Information about the debited funds.

              <Expandable title="properties">
                <ResponseField name="Currency" type="string">
                  **Returned values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

                  The currency of the debited funds (the sell currency).
                </ResponseField>

                <ResponseField name="Amount" type="integer">
                  An amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).

                  During a conversion, (`DebitedFunds.Amount` - `Fees`) \* `MarketRate` = `CreditedFunds.Amount`. 
                </ResponseField>
              </Expandable>
            </ResponseField>

            <ResponseField name="CreditedFunds" type="object">
              Information about the credited funds (`CreditedFunds` = `DebitedFunds` - `Fees`).

              <Expandable title="properties">
                <ResponseField name="Currency" type="string">
                  **Returned values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

                  The currency of the credited funds.
                </ResponseField>

                <ResponseField name="Amount" type="integer">
                  An amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).
                </ResponseField>
              </Expandable>
            </ResponseField>

            <ResponseField name="Fees" type="object">
              Information about the fees taken by the platform for this transaction (and hence transferred to the Fees Wallet).

              <Expandable title="properties">
                <ResponseField name="Currency" type="string">
                  **Returned values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

                  The currency of the fees.
                </ResponseField>

                <ResponseField name="Amount" type="integer">
                  An amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).
                </ResponseField>
              </Expandable>
            </ResponseField>

            <ResponseField name="Status" type="string">
              **Returned values:** `CREATED`, `SUCCEEDED`, `FAILED`

              The status of the transaction.
            </ResponseField>

            <ResponseField name="ResultCode" type="string">
              The code indicating the result of the operation. This information is mostly used to <a href="/errors/codes">handle errors</a> or for filtering purposes.
            </ResponseField>

            <ResponseField name="ResultMessage" type="string">
              The explanation of the result code.
            </ResponseField>

            <ResponseField name="ExecutionDate" type="Unix timestamp">
              The date and time at which the status changed to `SUCCEEDED`, indicating that the transaction occurred. The statuses `CREATED` and `FAILED` return an `ExecutionDate` of `null`.
            </ResponseField>

            <ResponseField name="Type" type="string">
              The type of transaction.
            </ResponseField>

            <ResponseField name="Nature" type="string">
              **Returned values:** `REGULAR`, `REPUDIATION`, `REFUND`, `SETTLEMENT`

              The nature of the transaction, providing more information about the context in which the transaction occurred:

              * `REGULAR` – Relative to most of the transactions (pay-ins, payouts, and transfers) in a usual workflow.
              * `REPUDIATION` – Automatic withdrawal of funds from the platform’s repudiation wallet as part of the dispute process (when the user has requested a chargeback).
              * `REFUND` – Reimbursement of a transaction to the user (pay-in refund), to a wallet (transfer refund), or of a payout (payout refund, only initiated by Mangopay).
              * `SETTLEMENT` – Transfer made to the repudiation wallet by the platform to settle a lost dispute.
            </ResponseField>

            <ResponseField name="CreditedWalletId" type="string">
              The unique identifier of the credited wallet.
            </ResponseField>

            <ResponseField name="DebitedWalletId" type="string">
              The unique identifier of the debited wallet.
            </ResponseField>
          </Expandable>
        </ResponseField>
      </Expandable>
    </ResponseField>
  </Accordion>
</AccordionGroup>

<ResponseExample>
  ```json 200 - Payouts-only example   theme={null}

  [
      {
          "Id":"155249846",
          "Tag":"Created using MANGOPAY API Collection Postman",
          "CreationDate":1667471665,
          "AuthorId":"146476890",
          "CreditedUserId":null,
          "DebitedFunds":{
              "Currency":"EUR",
              "Amount":1000
          },
          "CreditedFunds":{
              "Currency":"EUR",
              "Amount":990
          },
          "Fees":{
              "Currency":"EUR",
              "Amount":10
          },
          "Status":"SUCCEEDED",
          "ResultCode":"000000",
          "ResultMessage":"Success",
          "ExecutionDate":1667471665,
          "Type":"PAYOUT",
          "Nature":"REGULAR",
          "CreditedWalletId":null,
          "DebitedWalletId":"148968396"
      },
      {
          "Id":"155250949",
          "Tag":"Created using MANGOPAY API Collection Postman",
          "CreationDate":1667471872,
          "AuthorId":"146476890",
          "CreditedUserId":null,
          "DebitedFunds":{
              "Currency":"EUR",
              "Amount":16000
          },
          "CreditedFunds":{
              "Currency":"EUR",
              "Amount":15990
          },
          "Fees":{
              "Currency":"EUR",
              "Amount":10
          },
          "Status":"FAILED",
          "ResultCode":"001001",
          "ResultMessage":"Unsufficient wallet balance",
          "ExecutionDate":null,
          "Type":"PAYOUT",
          "Nature":"REGULAR",
          "CreditedWalletId":null,
          "DebitedWalletId":"148968396"
      }
  ]  

  ```
</ResponseExample>

<RequestExample>
  <RestNoBody />

  ```php PHP theme={null}
  <?php 

  require_once 'vendor/autoload.php';

  use MangoPay\MangoPayApi;
  use MangoPay\Libraries\ResponseException as MGPResponseException;
  use MangoPay\Libraries\Exception as MGPException;

  $api = new MangoPayApi();

  $api->Config->ClientId = 'your-client-id';
  $api->Config->ClientPassword = 'your-api-key';
  $api->Config->TemporaryFolder = 'tmp/';

  try {
      $bankAccountId = '198982485';

      $response = $api->BankAccounts->GetTransactions($bankAccountId);

      print_r($response);
  } catch(MGPResponseException $e) {
      print_r($e);
  } catch(MGPException $e) {
      print($e);
  }  
  ```

  ```javascript NodeJS   theme={null}
  const mangopayInstance = require('mangopay4-nodejs-sdk')
  const mangopay = new mangopayInstance({
    clientId: 'your-client-id',
    clientApiKey: 'your-api-key',
  })

  let bankAccount = {
    Id: '154876798',
  }

  const getBankAccountTransactions = async (bankAccountId) => {
    return await mangopay.BankAccounts.getTransactions(bankAccountId)
      .then((response) => {
        console.info(response)
        return response
      })
      .catch((err) => {
        console.log(err)
        return false
      })
  }

  getBankAccountTransactions(bankAccount.Id)  
  ```

  ```ruby Ruby   theme={null}
  require 'mangopay'

  MangoPay.configure do |client|
      client.preproduction = true
      client.client_id = 'your-client-id'
      client.client_apiKey = 'your-api-key'
      client.log_file = File.join(Dir.pwd, 'mangopay.log')
  end

  def listTransactionsBankAccount(bankAccountId)
      begin
          response = MangoPay::BankAccount.transactions(bankAccountId)
          puts response
          return response
      rescue MangoPay::ResponseError => error
          puts "Failed to fetch Transactions: #{error.message}"
          puts "Error details: #{error.details}"
          return false
      end
  end

  myBankAccount = {
      Id: '154876798'
  }

  listTransactionsBankAccount(myBankAccount[:Id])  
  ```

  ```java Java  theme={null}
  import com.google.gson.Gson;
  import com.google.gson.GsonBuilder;
  import com.mangopay.MangoPayApi;
  import com.mangopay.entities.Transaction;
  import java.util.List;

  public class ListBankAccountTransactions {
      public static void main(String[] args) throws Exception {
          MangoPayApi mangopay = new MangoPayApi();
          mangopay.getConfig().setClientId("your-client-id");
          mangopay.getConfig().setClientPassword("your-api-key");

          var bankAccountId = "bankacc_m_01HTJ7P7Y8K9DS5SZ08MDQRHHE";

          List<Transaction> transactions = mangopay.getUserApi().getBankAccountTransactions(bankAccountId);

          for (Transaction transaction : transactions) {
              Gson prettyPrint = new GsonBuilder().setPrettyPrinting().create();
              String prettyJson = prettyPrint.toJson(transaction);

              System.out.println(prettyJson);
          }
      }
  }
  ```

  ```python Python   theme={null}
  from pprint import pprint
  import mangopay

  mangopay.client_id='your-client-id'
  mangopay.apikey='your-api-key'

  from mangopay.api import APIRequest
  handler = APIRequest(sandbox=True)

  from mangopay.resources import NaturalUser, BankAccount

  natural_user = NaturalUser.get('213753890')

  bank_account = BankAccount(
      user_id = natural_user.id,
      id = '214651521'
  )

  transactions = BankAccount.get_transactions(self = bank_account)

  print('=== Transactions for Bank Account {} ==='.format(bank_account.id))

  for transaction in transactions:
      print()
      pprint(transaction._data)  
  ```

  ```csharp .NET  theme={null}
  using MangoPay.SDK;
  using MangoPay.SDK.Entities;
  using Newtonsoft.Json;

  class Program
  {
      static async Task Main(string[] args)
      {
          MangoPayApi api = new MangoPayApi();

          api.Config.ClientId = "your-client-id";
          api.Config.ClientPassword = "your-api-key";

          var bankAccountId = "bankacc_m_01HTJ7P7Y8K9DS5SZ08MDQRHHE";

          var viewTransactions = await api.Users.GetTransactionsForBankAccountAsync(bankAccountId, new Pagination(1, 100), null);

          string prettyPrint = JsonConvert.SerializeObject(viewTransactions, Formatting.Indented);
          Console.WriteLine(prettyPrint);
  	}
  }
  ```
</RequestExample>
